<?php
defined('_JEXEC') or die('Restricted access');
/*
ini_set('display_errors',1);
error_reporting(E_ALL & ~(E_STRICT|E_NOTICE));
*/
?>
<?php
class plgHikashoppaymentEBS extends JPlugin {
	 var $accepted_currencies = array('INR');
	 var $debugData = array();
	 
	 function onPaymentDisplay(&$order,&$methods,&$usable_methods){
	 	if(!empty($methods)){
			foreach($methods as $method){
				if($method->payment_type!='ebs' || !$method->enabled){
					continue;
				}
				if(!empty($method->payment_zone_namekey)){
					$zoneClass=hikashop_get('class.zone');
						$zones = $zoneClass->getOrderZones($order);
					if(!in_array($method->payment_zone_namekey,$zones)){
						return true;
					}
				}
				$currencyClass = hikashop_get('class.currency');
				$null=null;
				if(!empty($order->total)){
					$currency_id = intval(@$order->total->prices[0]->price_currency_id);
					$currency = $currencyClass->getCurrencies($currency_id,$null);
					if(!empty($currency) && !in_array(@$currency[$currency_id]->currency_code,$this->accepted_currencies)){
						return true;
					}
				}
				$usable_methods[$method->ordering]=$method;
			}
		}
		return true;
	 }
	 
	 function onPaymentSave(&$cart,&$rates,&$payment_id){
	 	$usable = array();
		$this->onPaymentDisplay($cart,$rates,$usable);
		$payment_id = (int) $payment_id;
		foreach($usable as $usable_method){
			if($usable_method->payment_id==$payment_id){
				return $usable_method;
			}
		}
		return false;
	 }
	 
	 function onAfterOrderConfirm(&$order,&$methods,$method_id){
	 	$action_url = "https://secure.ebs.in/pg/ma/sale/pay";
	 	$method =& $methods[$method_id];
	 	
	 	$currencyClass = hikashop_get('class.currency');
		$currencies=null;
		$currencies = $currencyClass->getCurrencies($order->order_currency_id,$currencies);
		$currency=$currencies[$order->order_currency_id];
		if($currency->currency_locale['int_frac_digits']>2)$currency->currency_locale['int_frac_digits']=2;
		
	 	hikashop_loadUser(true,true); //reset user data in case the emails were changed in the email code
		$user = hikashop_loadUser(true);
		$lang = &JFactory::getLanguage();
		$locale=strtolower(substr($lang->get('tag'),0,2));
		global $Itemid;
		$url_itemid='';
		if(!empty($Itemid)){
			$url_itemid='&Itemid='.$Itemid;
		}
		$return_url = HIKASHOP_LIVE.'index.php?option=com_hikashop&ctrl=checkout&task=notify&notif_payment=ebs&tmpl=component&lang='.$locale.$url_itemid.'&DR={DR}';
		$order_id = $order->order_id;
		
		$amount = round($order->order_full_price,(int)$currency->currency_locale['int_frac_digits']);		
		$description = "Order id is ".$order_id;
		$billing = $order->cart->billing_address;
		$shipping = $order->cart->shipping_address;
		$name = $billing->address_firstname." ".$billing->address_lastname;
		$address = $billing->address_street." ".$billing->address_street2;
		$country = strtoupper(substr($billing->address_country, 0, 2));
		$ship_name = $shipping->address_firstname." ".$shipping->address_lastname;
		$ship_address = $shipping->address_street." ".$shipping->address_street2;
		$ship_country = strtoupper(substr($shipping->address_country, 0, 2));
		$secret_key = $method->payment_params->secret_key;
		$account_id = $method->payment_params->account_id;
		$mode = $method->payment_params->mode;
		$hash = $secret_key."|".$account_id."|".$amount."|".$order_id."|".$return_url."|".$mode;
		$secure_hash = md5($hash);
		$vars = array(
			"account_id" => $method->payment_params->account_id,
			"return_url" => $return_url,
			"mode" => $method->payment_params->mode,
			"reference_no" => $order_id,
			"amount" => $amount,
			"description" => $description,
			"name" => $name,
			"address" => $address,
			"city" => $billing->address_city,
			"state" => $billing->address_state,
			"postal_code" => $billing->address_post_code,
			"country" => $country,	
			"phone" => $billing->address_telephone,
			"email" => $method->payment_params->email,
			"ship_name" => $ship_name,
			"ship_address" => $ship_address,
			"ship_city" => $shipping->address_city,
			"ship_state" => $shipping->address_state,	
			"ship_postal_code" => $shipping->address_post_code,	
			"ship_country" => $ship_country,		
			"secure_hash" => $secure_hash,
		);
		JHTML::_('behavior.mootools');
		$app =& JFactory::getApplication();
		$name = $method->payment_type.'_end.php';
		$path = JPATH_THEMES.DS.$app->getTemplate().DS.'hikashoppayment'.DS.$name;
		if(!file_exists($path)){
			if(version_compare(JVERSION,'1.6','<')){
				$path = JPATH_PLUGINS .DS.'hikashoppayment'.DS.$name;
			}else{
				$path = JPATH_PLUGINS .DS.'hikashoppayment'.DS.$method->payment_type.DS.$name;
			}
			if(!file_exists($path)){
				return true;
			}
		}
		require($path);
		return true;	 	
	 }
	 
	 function onPaymentNotification(&$statuses){
	 	//ob_get_clean();
	 	$pluginsClass = hikashop_get('class.plugins');
	 	$elements = $pluginsClass->getMethods('payment','ebs');	
	 	$element = reset($elements); 	
	 	
	 	$mailer =& JFactory::getMailer();
		$config =& hikashop_config();
		$sender = array(
		$config->get('from_email'),
		$config->get('from_name') );
		$mailer->setSender($sender);
		$mailer->addRecipient(explode(',',$config->get('payment_notification_email')));
		
	 	$path = JPATH_PLUGINS .DS.'hikashoppayment'.DS.'ebs'.DS.'Rc43.php';
	 	require($path);
	 	$Itemid = JRequest::getVar('Itemid');
		$url_itemid='';
		if(!empty($Itemid)){
			$url_itemid='&Itemid='.$Itemid;
		}
		
	 	$dr_val = JRequest::getVar('DR');
	 	$secret_key = $element->payment_params->secret_key;
	 	
	 	$DR = preg_replace("/\s/","+",$dr_val);
	 	$rc4 = new Crypt_RC4($secret_key);
	 	$QueryString = base64_decode($DR);
	 	$rc4->decrypt($QueryString);
	 	$QueryString = explode('&',$QueryString);
	 	
	 	$response = array();
	 	foreach($QueryString as $param){
 			$param = explode('=',$param);
 			$response[$param[0]] = urldecode($param[1]);
	 	}
	 	
	 	$orderClass = hikashop_get('class.order');
		$dbOrder = $orderClass->get($response['MerchantRefNo']);	
		$order = null;
		$order->order_id = $dbOrder->order_id;
		$order->old_status->order_status=$dbOrder->order_status;
		
		$currencyClass = hikashop_get('class.currency');
		$currencies=null;
		$currencies = $currencyClass->getCurrencies($dbOrder->order_currency_id,$currencies);
		$currency=$currencies[$dbOrder->order_currency_id];
	 	$price_check = round($dbOrder->order_full_price, (int)$currency->currency_locale['int_frac_digits'] );	 	
	 	
	 	$res_amount = $response['Amount'];
	 	$res_amount2 = round($res_amount, (int)$currency->currency_locale['int_frac_digits'] );	 	
		$failed = "";
		if($response['ResponseCode']==0){
			if($response['IsFlagged']=="NO" && $res_amount2==$price_check){
				$order->order_status = $element->payment_params->verified_status;	
				$order_text ="Transaction ID: ".$response['TransactionID'].", Response Message: ";
				$order_text .= "Transaction Successful.";		
			}
			else{
				$order->order_status = $element->payment_params->pending_status;
				$order_text ="Transaction ID: ".$response['TransactionID'].", Response Message: ";
				$order_text .= "The payment has been kept on hold until the manual verification is completed and authorized by EBS";
			} 		
		}
		else{
			$order->order_status = $element->payment_params->invalid_status;
			$order_text ="Transaction ID: ".$response['TransactionID'].", Response Message: ";
			$order_text .= "Transaction Failed.";
			$failed = 1;
		}
		
		$order->history->history_reason = "Payment Response";
		$order->history->history_notified = 0;
		$order->history->history_amount = $res_amount;
		$order->history->history_payment_id = $response['PaymentID'];
		$order->history->history_payment_method = 'EBS';
		$order->history->history_data = $order_text;
		$order->history->history_type = 'payment';
		
		if($dbOrder->order_status == $order->order_status) return true;
		$config =& hikashop_config();
		if($config->get('order_confirmed_status','confirmed')==$order->order_status){
			$order->history->history_notified = 1;
		}
				
		$order->mail_status = $statuses[$order->order_status];
	 	$mailer->setSubject(JText::sprintf('PAYMENT_NOTIFICATION_FOR_ORDER','EBS',$response['ResponseMessage'],$dbOrder->order_number));
		$body = JText::sprintf('ORDER_STATUS_CHANGED',$order->mail_status)."\r\n\r\n".$order_text;
		$mailer->setBody($body);
		$mailer->Send();
	 	if($orderClass->save($order)){	 		
	 		if($failed){
		 		$link = HIKASHOP_LIVE."index.php";
				$msg   = 'Transaction Failed. Your order has been cancelled.';
				$app = JFactory::getApplication();
				$app->enqueueMessage($msg, 'error');
				$app->redirect($link);
	 		}
	 		else{
	 			$return_url = HIKASHOP_LIVE.'index.php?option=com_hikashop&ctrl=checkout&task=after_end&order_id='.$order->order_id.$url_itemid;
	 			$msg   = 'Transaction Successful. Your order has been confirmed.';
				$app = JFactory::getApplication();
				//$app->enqueueMessage($msg, 'error');
				$app->redirect($return_url, $msg);
	 		}
	 	}	 			
	 	return true;
	 }
	 
	 function onPaymentConfiguration(&$element){
			$this->ebs = JRequest::getCmd('name','ebs');
			if(empty($element)){
				$element = null;
				$element->payment_name='EBS';
				$element->payment_description='You can pay by credit card or ebs using this payment method';
				$element->payment_images='MasterCard,VISA,Credit_card';
				$element->payment_type = $this->ebs;
				$element->payment_params = null;
				$element->payment_params->account_id = '5880';
				$element->payment_params->secret_key = 'ebskey';
				$element->payment_params->email;
				$element->payment_params->invalid_status='cancelled';
				$element->payment_params->pending_status='created';
				$element->payment_params->verified_status='confirmed';
				$element = array($element);
			}
			$obj = reset($element);
			if(empty($obj->payment_params->account_id)){
				$app =& JFactory::getApplication();
				$app->enqueueMessage('Please Enter the EBS Account ID');
			}
	 		if(empty($obj->payment_params->secret_key)){
				$app =& JFactory::getApplication();
				$app->enqueueMessage('Please Enter the EBS Secret Key');
			}
			
			$bar = & JToolBar::getInstance('toolbar');
			JToolBarHelper::save();
			JToolBarHelper::apply();
			JToolBarHelper::cancel();
			JToolBarHelper::divider();
			hikashop_setTitle('EBS','plugin','plugins&plugin_type=payment&task=edit&name='.$this->ebs);
			$app =& JFactory::getApplication();
			$app->setUserState( HIKASHOP_COMPONENT.'.payment_plugin_type', $this->ebs);
			$this->category = hikashop_get('type.categorysub');
			$this->category->type = 'status';
	 }
	 
	 function onPaymentConfigurationSave(&$element){
	 	// return true;
	 }
}
?>